<?php

if ( ! defined( 'PRIME_BEAUTY_SALON_URL' ) ) {
    define( 'PRIME_BEAUTY_SALON_URL', esc_url( 'https://www.themeignite.com/products/salon-wordpress-theme/', 'prime-beauty-salon') );
}
if ( ! defined( 'PRIME_BEAUTY_SALON_TEXT' ) ) {
    define( 'PRIME_BEAUTY_SALON_TEXT', __( 'Prime Beauty Salon PRO','prime-beauty-salon' ));
}
if ( ! defined( 'PRIME_BEAUTY_SALON_DOC_URL' ) ) {
    define( 'PRIME_BEAUTY_SALON_DOC_URL', esc_url( 'https://demo.themeignite.com/documentation/prime-beauty-salon-free', 'prime-beauty-salon') );
}
if ( ! defined( 'PRIME_BEAUTY_SALON_DOC_TEXT' ) ) {
    define( 'PRIME_BEAUTY_SALON_DOC_TEXT', __( 'For Refrence','prime-beauty-salon' ));
}

/**
 * Singleton class for handling the theme's customizer integration.
 *
 * @since  1.0.0
 * @access public
 */
final class Prime_Beauty_Salon_Customize {

	/**
	 * Returns the instance.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return object
	 */
	public static function get_instance() {

		static $instance = null;

		if ( is_null( $instance ) ) {
			$instance = new self;
			$instance->setup_actions();
		}

		return $instance;
	}

	/**
	 * Constructor method.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function __construct() {}

	/**
	 * Sets up initial actions.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function setup_actions() {

		// Register panels, sections, settings, controls, and partials.
		add_action( 'customize_register', array( $this, 'sections' ) );

		// Register scripts and styles for the controls.
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'enqueue_control_scripts' ), 0 );
	}

	/**
	 * Sets up the customizer sections.
	 *
	 * @since  1.0.0
	 * @access public
	 * @param  object  $manager
	 * @return void
	*/
	public function sections( $manager ) {

		// Load custom sections.
		load_template( trailingslashit( get_template_directory() ) . '/inc/premium-link/button-pro.php' );

		// Register custom section types.
		$manager->register_section_type( 'Prime_Beauty_Salon_Customize_Section_Pro' );

		// Register sections.
		$manager->add_section( new Prime_Beauty_Salon_Customize_Section_Pro( $manager,'prime_beauty_salon_button_link', array(
			'priority'   => 1,
			'title'    => esc_html( PRIME_BEAUTY_SALON_TEXT, 'prime-beauty-salon' ),
			'pro_text' => esc_html__( 'GO PRO', 'prime-beauty-salon' ),
			'pro_url'  => esc_url( PRIME_BEAUTY_SALON_URL)
		) )	);
		// Register sections.
		$manager->add_section( new Prime_Beauty_Salon_Customize_Section_Pro( $manager,'prime_beauty_salon_doc_button_link', array(
			'priority'   => 1,
			'title'    => esc_html( PRIME_BEAUTY_SALON_DOC_TEXT, 'prime-beauty-salon' ),
			'pro_text' => esc_html__( 'Free Docs', 'prime-beauty-salon' ),
			'pro_url'  => esc_url( PRIME_BEAUTY_SALON_DOC_URL)
		) )	);
	}

	/**
	 * Loads theme customizer CSS.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return void
	 */
	public function enqueue_control_scripts() {

		wp_enqueue_script( 'prime-beauty-salon-customize-controls', trailingslashit( get_template_directory_uri() ) . '/inc/premium-link/assets/customize-controls.js', array( 'customize-controls' ) );

		wp_enqueue_style( 'prime-beauty-salon-customize-controls', trailingslashit( get_template_directory_uri() ) . '/inc/premium-link/assets/customize-controls.css' );
	}
}

// Doing this customizer thang!
Prime_Beauty_Salon_Customize::get_instance();